<?xml version="1.0"?>

<st-source>
<!-- Changes in change set PV -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on August 13, 2008 at 7:52:06 am</time-stamp>


<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>processing</category>

<body package="PVAdaptor-Schema" selector="processAll:">processAll: inputs 
	" If the schema is not a multifile join, there should ordinarily be only one file to process at a time.
	If multiple files are found, it is probably a mistake (i.e. script did not bother to set a timestamp.
	In this case sort files by local name as a meek protection (increases likelihood files will be processed
	in desired order. Quite frankly, the only reason we bother is because there are some sloppy test cases
	that don't set descriptor's timestamp "
	
	| realInputs endTimestamp |
	realInputs := 
		(inputs size &gt; 1 and: [schema multiFileJoin not]) 
			ifTrue: 
				[self system 
					logWarning: #MULTIPLE_FILES_PER_PERIOD_DETECTED
					messageId: #DC10428
					text: 
						'Multiple files per period ' , 
							inputs anyOne timestamp smeeToPrimitiveNumber pvOpportunisticPrintString , 
								' are found -- this should not happen. Please check the design script and data feed mechanism'.
				(inputs asSortedCollection: [:i1 :i2 | i1 localName &lt; i2 localName]) asOrderedCollection]
			ifFalse: [inputs].
	realInputs do: 
		[:each | 
		schema process: each.
		each markScheduled].
	realInputs isEmpty 
		ifFalse: 
			[endTimestamp := 
				(periodPolicy endOfPeriodContainingTimestamp: 
					(self toSeconds: realInputs anyOne timestamp)) + 1.
			schema process: (PvStreamHeartbeat timestamp: endTimestamp)]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="process:">process: eachInput
	
	^handlerBlock value: eachInput</body>
</methods>


<methods>
<class-id>PROVISO.PvStreamHeartbeat</class-id> <category>public</category>

<body package="PV-Support" selector="acceptProcessor:">acceptProcessor: aProcessor

	aProcessor processHeartbeat: self</body>
</methods>


<reorganize>
<class-id>PROVISO.PvStreamHeartbeat</class-id> <organization>('accessing' #date #date: #eventId #metricRecordManager #metricRecordManager: #shouldStartNewPeriod #shouldStartNewPeriod: #timestamp #timestamp:)
('printing' #printOn:)
('testing' #isHeartbeat #isRecomputationAction)
('initialize-release' #initialize)
('comparing' #=)
('public' #acceptProcessor:)
</organization>
</reorganize>

<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>public</category>

<body package="PVAdaptor-Schema" selector="acceptProcessor:">acceptProcessor: aProcessor

	aProcessor processInputDescriptor: self</body>
</methods>


<reorganize>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <organization>('commit actions' #addCommitMessagesTo: #doneDirectory #doNotProcess #enqueueLinkToOutput #enqueueMoveToDone #ignoreProcessing)
('save/restore' #adaptor #materializeSchema: #save #serializeSchema)
('accessing' #acquire #acquiredTimestamp #acquiredTimestamp: #adaptor: #addCommitMessage: #ageDifference:ifUnknown: #childRecordCountTotal #commitMessages #commitMessages: #elapsedSeconds #fileInterface #filenameInDoDirectory #fileSize #fileSize: #ignore #ignore: #incrementNoNewInputCount #inputSourceStatus #inputSourceStatus: #inputSourceStatusString #inputSourceStatusString: #localName #localName: #localNameString #markScheduled #maxTimestamp #maxTimestamp: #name #periodTimestamp #periodTimestamp: #processedRecordCount #processedRecordCount: #processedTimestamp #processedTimestamp: #recordNumber #recordNumber: #recordsPerMinute #rejectedRecordCount #rejectedRecordCount: #remoteName #remoteName: #resetScheduled #scheduledTimestamp #schema #schema: #setStatusMissingForInputSource: #setStatusPresentForInputSource: #setStatusUnknownForInputSource: #startTimestamp #startTimestamp: #statusAtSource: #stopTimestamp #stopTimestamp: #stream #stream: #timestamp #timestamp: #uri #uri: #uriInDoDirectory #uriObject)
('events' #parsedObject:)
('testing' #alreadyAcquired #alreadyProcessed #alreadyScheduled #canBePurgedAtSeconds:withRetentionDuration:forInputSources: #hasExceededHoldGatePeriodFor: #isAssumedPresentAtSource: #isInDoDirectory #isMissingAtSource: #isOlderThan:relativeTo: #isPendingProcessing #isPresentAtSource: #isReadyForProcessing: #isTenuredForProcessing #processingStatusCode)
('merging' #mergeWith:)
('prototype builtins' #toString)
('parsing' #parseNotifying:)
('private' #lastFileTimestamp #resetCommitMessages)
('initialize-release' #initialize)
('user interface' #emphasisForTreeViewClosed #inspectorChildren)
('icons' #icon)
('public' #acceptProcessor:)
</organization>
</reorganize>

<methods>
<class-id>PROVISO.UBA.InputSchemaProcessor</class-id> <category>back end callbacks</category>

<body package="NGUBA-Application" selector="process:">process: aProcessorAcceptor

	aProcessorAcceptor acceptProcessor: self</body>

<body package="NGUBA-Application" selector="processHeartbeat:">processHeartbeat: aPvHeartbeat

	"do nothing"</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputSchemaProcessor</class-id> <category>building</category>

<body package="NGUBA-Application" selector="connectAsInputToSingleInputOperator:builder:">connectAsInputToSingleInputOperator: aClientOperator builder: aPlanBuilder 
	" Second leg of dispatch. We now know that the client is a single-input operator, 
	now dispatch based on the input type -- in this case input schema "
	
	self schema handlerBlock: [:eachInput | self process: eachInput].
	self startAsDaemon: false.		" Processing is synchronous "
	^aPlanBuilder 
		connectInputSchema: self
		toSingleInputOperator: aClientOperator</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputSchemaProcessor</class-id> <category>private</category>

<body package="NGUBA-Application" selector="processLoop">processLoop

	self process: self queue next</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputSchemaMultiJoinProcessor</class-id> <category>private</category>

<body package="NGUBA-Application" selector="checkForEndOfPeriod:">checkForEndOfPeriod: seconds 
	
	| period |
	period := self periodPolicy startOfPeriodContainingTimestamp: seconds.
	self periodPolicy start ifNil: [self periodPolicy start: period].
	self periodPolicy start = period 
		ifFalse: 
			[self processAll.
			self periodPolicy start: period]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputSchemaMultiJoinProcessor</class-id> <category>back end callbacks</category>

<body package="NGUBA-Application" selector="processHeartbeat:">processHeartbeat: aPvHeartbeat

	self checkForEndOfPeriod: aPvHeartbeat timestamp.</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputSchemaMultiJoinProcessor</class-id> <category>public</category>

<body package="NGUBA-Application" selector="processInputDescriptor:">processInputDescriptor: anInputDescriptor
	| stream seconds |
	(self shouldIgnore: anInputDescriptor)
		ifTrue: [^self].
	(anInputDescriptor timestamp = 0 and: [self schema filePeriod notNil]) 
		ifTrue: [self logNoTimestampForDescriptor: anInputDescriptor].
	seconds := anInputDescriptor timestamp asPvTimestamp asSeconds.
	self checkForEndOfPeriod: seconds.
	stream := self newStreamFor: anInputDescriptor.
	descriptorStreams at: anInputDescriptor put: stream.
	mergeStream addStream: stream.</body>

<body package="NGUBA-Application" selector="schema:">schema: anInputSchema

	super schema: anInputSchema.
	self setPeriod: (anInputSchema filePeriod ifNil: [1]).</body>
</methods>


<reorganize>
<class-id>PROVISO.UBA.InputSchemaMultiJoinProcessor</class-id> <organization>('public' #basicProcessInputDescriptor: #processInputDescriptor: #produceRecord: #schema:)
('initialize-release' #initialize #newMergeStream #resetDescriptors)
('private' #basicFinishParsingFor: #basicProduceRecord: #basicSendEndHeartbeat: #basicSendStartHeartbeat: #checkForEndOfPeriod: #descriptorsReadyForProcessing #finishParsingFor: #finishParsingForAll: #newStreamFor: #processAll #readyForProcessing: #sendEndHeartbeat: #sendEndHeartbeatForAll: #sendStartHeartbeat: #sendStartHeartbeatForAll: #shouldIgnore:)
('back end callbacks' #processHeartbeat:)
</organization>
</reorganize>


</st-source>
