<?xml version="1.0"?>

<st-source>
<!-- Changes in change set PV -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on August 15, 2008 at 10:06:20 am</time-stamp>


<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>initialize-release</category>

<body package="PVAdaptor-Schema" selector="resetScheduledDescriptors">resetScheduledDescriptors
	
	schema inputDescriptors do: 
		[:each | 
		each alreadyProcessed 
			ifFalse: [each scheduledTimestamp: nil]]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>initialize-release</category>

<body package="PVAdaptor-Schema" selector="initializeWith:">initializeWith: anInputSchema 
	
	| filePeriod |
	schema := anInputSchema.
	filePeriod := schema filePeriod ifNil: [1].
	periodPolicy := PeriodPolicy length: filePeriod.
	self resetScheduledDescriptors</body>
</methods>


<methods>
<class-id>PROVISO.UBA.FecordSchema</class-id> <category>accessing</category>

<body package="PVAdaptor-Schema" selector="inputSchema">inputSchema
	&lt;getterNamed: #inputSchema&gt;
	^(self parent ifNil: [^nil]) inputSchema</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputDescriptor class</class-id> <category>class initialization</category>

<body package="PVAdaptor-Schema" selector="initializeSmeeProperties">initializeSmeeProperties
	
	super initializeSmeeProperties.
	self smeeInterface propertyAccessorsForPersistence
		at: #schema
			put: 
				(SmeeAccessorProperty 
					key: #schema
					get: #serializeSchema
					put: #materializeSchema:);
		at: #scheduledTimestamp
			put: 
				(SmeeAccessorProperty 
					key: #scheduledTimestamp
					get: #scheduledTimestamp
					put: #scheduledTimestamp:)</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>accessing</category>

<body package="PVAdaptor-Schema" selector="scheduledTimestamp:">scheduledTimestamp: aDate 
	
	scheduledTimestamp := aDate</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>accessing</category>

<body package="PVAdaptor-Schema" selector="markScheduled">markScheduled

	scheduledTimestamp := SmeeDate nowUTC.
	self save.</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>merging</category>

<body package="PVAdaptor-Schema" selector="mergeWith:">mergeWith: anInputDescriptor 
	
	| changed |
	changed := false.
	(self ignore not and: [anInputDescriptor ignore]) 
		ifTrue: 
			[changed := true.
			self ignore: true].
	(anInputDescriptor timestamp notNil and: [anInputDescriptor timestamp ~= self timestamp])
		ifTrue: 
			[changed := true.
			self timestamp: anInputDescriptor timestamp].
	(anInputDescriptor alreadyAcquired and: [self alreadyAcquired not])
		ifTrue: 
			[changed := true.
			self acquiredTimestamp: anInputDescriptor acquiredTimestamp].
	(anInputDescriptor alreadyProcessed and: [self alreadyProcessed not])
		ifTrue: 
			[changed := true.
			self processedTimestamp: anInputDescriptor processedTimestamp].
	(anInputDescriptor alreadyScheduled and: [self alreadyScheduled not])
		ifTrue: 
			[changed := true.
			self scheduledTimestamp: anInputDescriptor scheduledTimestamp].
	^changed</body>
</methods>


<methods>
<class-id>PROVISO.UBA.Record</class-id> <category>accessing</category>

<body package="PVAdaptor Core" selector="schema">schema
	&lt;getterNamed: #schema&gt;
	^schema</body>
</methods>



</st-source>
