<?xml version="1.0"?>

<st-source>
<!-- Changes in change set PATCH-RA503373 -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on August 19, 2008 at 7:16:40 am</time-stamp>


<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>testing</category>

<body package="PVAdaptor-Schema" selector="hasValidTimestamp">hasValidTimestamp

	self timestamp ifNil: [^false].
	self timestamp isSmeeDate ifFalse: [^false].
	self timestamp isValid ifFalse: [^false].
	self timestamp value == 0 ifTrue: [^false].
	^true</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputSchemaProcessor</class-id> <category>private</category>

<body package="NGUBA-Application" selector="process:ifValidDo:">process: anInputDescriptor ifValidDo: aBlock 
	
	| currentDesc |
	currentDesc := 
		self schema inputDescriptors
			at: anInputDescriptor name
			ifAbsent: [anInputDescriptor].
	currentDesc alreadyProcessed 
		ifTrue: [^self].
	currentDesc ignore 
		ifTrue: 
			[currentDesc doNotProcess.
			^self].
	(self schema isValidInputDesctriptor: anInputDescriptor) 
		ifFalse: 
			[self schema logInputDecriptorMissingFor: anInputDescriptor.
			anInputDescriptor doNotProcess.
			^self].
	((self hasValidTimestampForDescriptor: anInputDescriptor) and: 
		[self schema filePeriod notNil]) 
			ifFalse: [self logNoTimestampForDescriptor: anInputDescriptor].
	self descriptor: anInputDescriptor.
	anInputDescriptor adaptor: self.
	[aBlock value: currentDesc] 
		ensure: 
			[self descriptor: nil.
			anInputDescriptor adaptor: nil]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputSchemaProcessor</class-id> <category>private</category>

<body package="NGUBA-Application" selector="hasValidTimestampForDescriptor:">hasValidTimestampForDescriptor: aDescriptor
	^aDescriptor hasValidTimestamp</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputSchemaProcessor</class-id> <category>back end callbacks</category>

<body package="NGUBA-Application" selector="processInputDescriptor:">processInputDescriptor: anInputDescriptor 
	
	[self maxTimestamp: 0.
	self 
		process: anInputDescriptor
		ifValidDo: 
			[:validDesc | 
			self schema triggerOnOpenWith: validDesc.
			self sendStartHeartbeat: validDesc timestamp.
			self system extendedStatus: 
				'Processing ' , validDesc localName , ' for ' , 
					validDesc timestamp pvOpportunisticPrintString.
			self schema 
				parseInput: validDesc
				notifying: self.
			self schema triggerOnCloseWith: validDesc.
			self finishParsingFor: validDesc]] 
				on: Error
				do: 
					[:ex | 
					self 
						handleInputError: ex
						for: anInputDescriptor]</body>
</methods>



</st-source>
