<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on August 29, 2008 at 7:25:09 pm</time-stamp>


<methods>
<class-id>PROVISO.UBA.PvSAMDeviceSchema</class-id> <category>enumerating</category>

<body package="SAM-Interface" selector="processFullDumpFor:">processFullDumpFor: anInterface 
	
	| sem procHolder |
	procHolder := ##(ValueHolder new).
	sem := ##(Semaphore forMutualExclusion).
	sem critical: 
		["Ensure that we aren't already running a full dump"(procHolder value notNil and: [procHolder value isTerminated not]) 
			ifTrue: [^'A full dump is already in progress'].
		"Now, fork a full dump"
		procHolder value: 
			(self system 
				fork: 
					[[self adaptor environmentDo: 
						[[anInterface preFullDump.
						self onFullDump valueWithThis: self.
						anInterface postFullDump] 
							on: Error
							do: 
								[:ex | 
								self logFullDumpInterrupted: ex.
								(ex isResumable or: [ex isKindOf: SmeeError]) 
									ifFalse: 
										[(self timeFacade delayForMilliseconds: 500) wait.
										ex retry]]]] 
											ensure: [procHolder value: nil]]
				named: 'Full Dump'
				at: self system applicationPriority)].
	^'A full dump has been scheduled'</body>
</methods>

</st-source>
