<?xml version="1.0"?>

<st-source>
<!-- Changes in change set 2008-12-04-SAM -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on December 4, 2008 at 9:06:26 pm</time-stamp>


<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>enumerating</category>

<body package="SAM-Interface" selector="preFullDump">preFullDump
	self currentApplication setStatusMessage: 'SAM full dump started at: ', self timeFacade now printString.
	"self stopJms." "this is no longer needed because JMS should always be up"
	self cleanupTempDirectory</body>
</methods>


<remove-selector>
<class-id>PROVISO.PvSAMInterface</class-id> <selector>isFullDumpPending</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>process management</category>

<body package="SAM-Interface" selector="getStringFrom:onError:">getStringFrom: aStream onError: aOneArgumentBlock 
	
	^[aStream 
		ifNil: [nil]
		ifNotNil: [:strm | aStream peek ifNotNil: [String readNetStringFrom: aStream]]] 
			on: Error
			do: 
				[:ex | 
				aOneArgumentBlock value: ex.
				aStream setToEnd.
				nil]</body>
</methods>


<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>process management</category>

<body package="SAM-Interface" selector="getStringFrom:">getStringFrom: aStream 
	
	^self getStringFrom: aStream onError: [:ex | self logProtocolError: ex]</body>

<body package="SAM-Interface" selector="processStderr:">processStderr: testBlock 
	"This method is called by the eventService and is designed to run forever, reading infomration from the pipe connection with the external JMS listener process"
	
	self 
		processStrings: [self getStringFrom: stderr onError: [:ex | ]]
		do: [:str | self processErr: str]
		while: [testBlock value and: [externalProcess notNil]]</body>

<body package="SAM-Interface" selector="processStdout:">processStdout: testBlock 
	"This method is called by the eventService and is designed to run forever, reading infomration from the pipe connection with the external JMS listener process"
	
	self 
		processStrings: [self getStringFrom: stdout]
		do: [:str | self process: str]
		while: [testBlock value and: [externalProcess notNil]]</body>

<body package="SAM-Interface" selector="runJmsProcess:">runJmsProcess: testBlock 
	"This method is called by the monitorService and is designed to run forever, keeping the external JMS listener process running"
	
	| delay tmp |
	delay := 0.
	tmp := Time microsecondClock.
	[self startExternalProcess.
	[testBlock value] 
		whileTrue: 
			[self stillAlive 
				ifFalse: 
					[self logStaleJMSConnection.
					Time microsecondClock - tmp &gt; 60000000 
						ifTrue: [delay := 0]
						ifFalse: 
							[delay = 0 
								ifTrue: [delay := 100]
								ifFalse: [delay := delay * 2 min: 60000]].
					tmp := Time microsecondClock.
					self stopExternalProcess.
					delay = 0 
						ifFalse: [(Delay forMilliseconds: delay) wait].
					self startExternalProcess].
			[externalProcess wait] timeoutMilliseconds: 500]] 
				ensure: [self stopExternalProcess]</body>
</methods>



</st-source>
