<?xml version="1.0"?>

<st-source>
<!-- Changes in change set 2008-12-09 -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on December 10, 2008 at 6:13:31 am</time-stamp>


<methods>
<class-id>PROVISO.PvSAMDeviceConnection</class-id> <category>private</category>

<body package="SAM-Interface" selector="send:timeout:">send: aString timeout: msecs 
	"&lt;HttpResponse&gt; Send the given XML string to the server and get the response...if we fail, try to disconnect the current client, create a new client, and resend the request.

	NOTE: we may need to fork the #executeAndGetResponse in the future so that we can kill it if it takes longer than the timeout to execute"
	
	| request |
	request := self newRequestWithContents: aString.
	^self critical: 
		[[self sendAndRetry: request] 
			on: Error
			do: [:t4 | self serverUnreachable: t4 description]]</body>

<body package="SAM-Interface" selector="sendAndRetry:">sendAndRetry: request 
	
	| retries |
	retries := 0.
	^[self client request: request.
	self client executeAndGetResponse] 
		on: Net.HttpException
		do: 
			[:httpIssue | 
			retries := retries + 1.
			retries &lt; 5 
				ifTrue: [httpIssue retry]
				ifFalse: [httpIssue pass]]</body>
</methods>



</st-source>
