<?xml version="1.0"?>

<st-source>
<!-- Changes in change set 2008-12-10-SAM -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on December 11, 2008 at 5:38:20 pm</time-stamp>


<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>enumerating</category>

<body package="SAM-Interface" selector="haPerform:">haPerform: aBlock 
	
	| retries |
	retries := 0.
	^self critical: 
		[self tryReconnectInTurnUntilSuccessful.
		self checkForPrimaryAvailability.
		[self waitUntilReady.
		aBlock value: self connection] 
			on: PvSAMDeviceConnection serverUnreachableError
			do: 
				[:ex | 
				self connection disconnect.
				self system 
				logInfo: #SAM_CONNECT
				messageId: nil
				text: 
					'Connection to sam server was lost due to the following error: ' ,	ex messageText printString,'...Retrying connection.'.
				(self 
					test: self normalStateId
					set: self connectingStateId) 
						ifTrue: 
							[self tryReconnectInTurnUntilSuccessful.
							self state: self normalStateId].
				(self timeFacade delayForMilliseconds: 20) wait.
				retries := retries + 1.
				(retries \\ 10 = 0 and: 
					[self system debugFlags at: #DEBUG_WALKBACK_ON_INPUT_ERROR ifAbsent: [false]]) 
						ifTrue: [PvWalkbackWriter new dumpWalkbackForException: ex].
				self startJms.
				ex retry]]</body>

<body package="SAM-Interface" selector="startJms">startJms	
	connection ifNotNil: [connection jmsInterface ifNotNil: [:jms | jms stillAlive ifFalse: [jms start]]]</body>
</methods>



</st-source>
