<?xml version="1.0"?>

<st-source>
<!-- Changes in change set PV -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on September 3, 2008 at 7:13:02 pm</time-stamp>


<methods>
<class-id>Kernel.BlockClosure</class-id> <category>PROVISO</category>

<body package="PV-Base Extensions" selector="onImmediateNotUnderstoodDo:">onImmediateNotUnderstoodDo: exceptionBlock 
	"Only signal MessageNotUnderstood if the message send is not an immediate send in the block"
	
	^self 
		on: MessageNotUnderstood
		do: 
			[:problem | 
			| myContext problemContext |
			myContext := thisContext supposedHome.
			problemContext := problem initialContext sender sender sender.
			(problemContext == myContext and: 
				[self method allSymbolLiterals includes: problem message selector]) 
					ifTrue: [exceptionBlock valueWithPossibleArgs: (Array with: problem)]
					ifFalse: [problem pass]]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.UBAAbstractServer</class-id> <category>logging</category>

<body package="PVAdaptor-Application" selector="logInvalidLicense:">logInvalidLicense: licenseName

	self system 
		logWarning: #INVALID_LICENSE
		messageId: #DL39206
		template: 'License(&lt;1s&gt;) is invalid or missing'
		arguments: (Array with: licenseName)</body>
</methods>


<methods>
<class-id>PROVISO.UBA.UBAAbstractServer</class-id> <category>adapting</category>

<body package="PVAdaptor-Application" selector="handleODBCLicenseError:">handleODBCLicenseError: ex 
	| licenseNames |
	licenseNames := (String new: 40) streamContentsDo: 
					[:stream | 
					self currentApplication dataDirectLicenseNames 
						do: [:each | stream nextPutAll: each]
						separatedBy: [stream nextPutAll: ' or ']].
	self logInvalidLicense: licenseNames.
	^ex return</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>public</category>

<body package="PVAdaptor-Schema" selector="processInputsForAdaptor:">processInputsForAdaptor: anAdaptor 
	
	| acquiredAnything scheduledAnything noNewInputBlock |
	noNewInputBlock := [:each | each incrementNoNewInputCount].
	[acquiredAnything := self acquireOnNoNewInputDo: noNewInputBlock.
	scheduledAnything := self schedule.
	acquiredAnything or: [scheduledAnything]] 
		whileTrue: 
			[schema shouldAcquireOnlyOnce 
				ifTrue: [^self].
			noNewInputBlock := [:each | ]]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.RecordSchema</class-id> <category>copying</category>

<body package="PVAdaptor-Schema" selector="postCopy">postCopy

	super postCopy.
	properties := properties copy</body>
</methods>


<remove-selector>
<class-id>PROVISO.UBA.UBAServer</class-id> <selector>builderFromXml:withId:ifPresent:ifAbsent:</selector>
</remove-selector>

<remove-selector>
<class-id>PROVISO.UBA.PvAggregator class</class-id> <selector>smeeNewWith:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.UBA.AbstractStreamWriter</class-id> <category>private</category>

<body package="NGUBA-Application" selector="filenameForStream:">filenameForStream: aPvFmBofStreamOrInternalStream 
	
	^[aPvFmBofStreamOrInternalStream filename] onImmediateNotUnderstoodDo: [nil]</body>
</methods>


<remove-selector>
<class-id>PROVISO.UBA.AbstractStreamWriter</class-id> <selector>writeHeartbeatFileFor:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.UBA.InputSchema</class-id> <category>acquisition</category>

<body package="PVAdaptor-Schema" selector="scanForInputs:">scanForInputs: aURI 
	
	| answer foundDescriptors allURIs |
	aURI ifNil: [^#()].
	[allURIs := aURI allURIs] 
		on: Error
		do: 
			[:ex | 
			self 
				logErrorRetrievingURIs: aURI
				description: ex description.
			(self isInputLate: aURI) 
				ifTrue: [self logLateInput: aURI].
			^OrderedCollection new].
	foundDescriptors := OrderedCollection new.
	allURIs do: 
		[:eachURI | 
		| newInput |
		newInput := self parseURI: eachURI.
		(newInput 
			isOlderThan: self inputAgeLimit * 3600
			relativeTo: self currentSeconds) 
				ifTrue: [self ignoreInputDescriptor: newInput]
				ifFalse: 
					[foundDescriptors add: newInput]].
	answer := OrderedCollection new: foundDescriptors size.
	foundDescriptors do: 
		[:foundDescriptor | 
		| oldDescriptor |
		oldDescriptor := 
			self adaptor 
				inputDescriptorNamed: foundDescriptor name
				ifAbsent: [nil].
		oldDescriptor isNil 
			ifTrue: 
				[self adaptor addInputDescriptor: foundDescriptor.
				answer add: foundDescriptor]
			ifFalse: 
				[(oldDescriptor mergeWith: foundDescriptor) 
					ifTrue: [self adaptor updateInputDescriptor: oldDescriptor].
				answer add: oldDescriptor]].
	answer isEmpty 
		ifTrue: 
			[(self isInputLate: aURI) 
				ifTrue: [self logLateInput: aURI]]
		ifFalse: [self updateLastFoundNewInputsSeconds: aURI].
	^answer</body>
</methods>



</st-source>
