<?xml version="1.0"?>

<st-source>
<!-- Changes in change set 2008-11-19-SAM-2 -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on November 19, 2008 at 9:27:43 pm</time-stamp>


<class>
<name>PvSAMJmsInterface</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>descriptor stdioConnection stdin stdout stderr eventStream externalProcess monitorService lastKeepAlive eventCallback stdoutListener stderrListener receivedKeepAlive connection environment inventoryChangeQueue inventoryChangeService lastServerStartTime </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>SAM-Interface</category>
<attributes>
<package>SAM-Interface</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.UBA.PvSAMDeviceSchema</class-id> <category>enumerating</category>

<body package="SAM-Interface" selector="processFullDumpFor:">processFullDumpFor: anInterface 
	
	anInterface connection ifNotNil: 
		[:conn | 
		conn jmsInterface doInventoryChange: 
			[self adaptor environmentDo: 
				[[anInterface preFullDump.
				self onFullDump valueWithThis: self.
				anInterface postFullDump] 
					on: Error
					do: 
						[:ex | 
						self logFullDumpInterrupted: ex.
						(ex isResumable or: [ex isKindOf: SmeeError]) 
							ifFalse: 
								[(self timeFacade delayForMilliseconds: 500) wait.
								ex retry].
						conn jmsInterface markFullDumpInterrupted]]]].
	^'A full dump has been scheduled'</body>
</methods>


<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>enumerating</category>

<body package="SAM-Interface" selector="activateSwitchedConnection">activateSwitchedConnection
	
	self activateDescriptor: self descriptor.
	self attemptResync: true.
	self system 
		logWarning: #SAM_RESTORED_PRIMARY
		messageId: #DC10620
		text: 'Successfully switched back to primary SAM server'</body>

<body package="SAM-Interface" selector="basicCheckForPrimaryAvailability">basicCheckForPrimaryAvailability
	
	| oldDescriptor oldConnection oldPosition |
	self system 
		logWarning: #SAM_CHECK_PRIMARY
		messageId: #DC10617
		text: 'Check for primary SAM server availability'.
	self lastPrimarySwitchOverAttempt: self timeFacade now asSeconds.
	oldPosition := self currentDescriptorPosition.
	oldDescriptor := self descriptor.
	self currentDescriptorPosition: 1.
	oldConnection := connection.
	self testConnection 
		ifFalse: 
			[connection disconnect.
			self 
				rollbackCurrentConnection: oldConnection
				using: oldPosition.
			^self].
	oldConnection notNil 
		ifTrue: [oldConnection disconnect].
	self deactivateDescriptor: oldDescriptor.
	self activateSwitchedConnection</body>

<body package="SAM-Interface" selector="rollbackCurrentConnection:using:">rollbackCurrentConnection: oldConnection using: oldPosition 
	
	self currentDescriptorPosition: oldPosition.
	connection := oldConnection.
	self system 
		logWarning: #SAM_PRIMARY_UNAVAILABLE
		messageId: #DC10619
		text: 'Failed to connect to SAM service.'</body>
</methods>


<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>enumerating</category>

<body package="SAM-Interface" selector="activateDescriptor:">activateDescriptor: aDescriptor 
	"enable this connection"
	
	self startJms</body>

<body package="SAM-Interface" selector="checkForPrimaryAvailability">checkForPrimaryAvailability
	
	self shouldAttemptPrimarySwitchOver 
		ifFalse: [^self].
	self basicCheckForPrimaryAvailability</body>

<body package="SAM-Interface" selector="haPerform:">haPerform: aBlock 
	
	| retries |
	retries := 0.
	^self critical: 
		[self tryReconnectInTurnUntilSuccessful.
		self checkForPrimaryAvailability.
		[self waitUntilReady.
		"self peformFullResync."
		aBlock value: self connection] 
			on: PvSAMDeviceConnection serverUnreachableError
			do: 
				[:ex | 
				self connection disconnect.
				self system 
				logInfo: #SAM_CONNECT
				messageId: nil
				text: 
					'Connection to sam server was lost due to the following error: ' ,	ex messageText printString,'...Retrying connection.'.
				(self 
					test: self normalStateId
					set: self connectingStateId) 
						ifTrue: 
							[self tryReconnectInTurnUntilSuccessful.
							self state: self normalStateId].
				(self timeFacade delayForMilliseconds: 20) wait.
				retries := retries + 1.
				(retries \\ 10 = 0 and: 
					[self system debugFlags at: #DEBUG_WALKBACK_ON_INPUT_ERROR ifAbsent: [false]]) 
						ifTrue: [PvWalkbackWriter new dumpWalkbackForException: ex].
				ex retry]]</body>

<body package="SAM-Interface" selector="postFullDump">postFullDump
	self currentApplication ifNotNil:[:anApp| anApp setStatusMessage: 'SAM full dump ended at: ', self timeFacade now printString].
	"self startJms." "this is no longer needed because JMS should always be up"
	self attemptResync: false</body>

<body package="SAM-Interface" selector="testConnection">testConnection
	
	connection := self connect.
	self system 
		logInfo: #SAM_CONNECT
		messageId: nil
		text: 'Attempting connection to sam server: ' , self descriptor soapURI asString.
	^[connection testConnection.
	true] 
		on: Error
		do: 
			[:err | 
			self system 
				logInfo: #SAM_CONNECT
				messageId: nil
				text: 
					'Connection to sam server failed on ' , self descriptor soapURI asString , '. ' , 
						err messageText printString.
			^false]</body>
</methods>


<methods>
<class-id>PROVISO.PvSAMJmsInterface class</class-id> <category>creation</category>

<body package="SAM-Interface" selector="on:">on: aJmsConnection

	^self new
		connection: aJmsConnection;
		yourself</body>
</methods>


<reorganize>
<class-id>PROVISO.PvSAMJmsInterface class</class-id> <organization>('creation' #on:)
</organization>
</reorganize>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>accessing</category>

<body package="SAM-Interface" selector="descriptor">descriptor

	^descriptor</body>

<body package="SAM-Interface" selector="inventoryChangeQueue">inventoryChangeQueue

	^inventoryChangeQueue</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>process management</category>

<body package="SAM-Interface" selector="processInventoryChangeEvents:">processInventoryChangeEvents: testBlock 
	
	[testBlock value] 
		whileTrue: [self processNextInventoryChangeEvent]</body>

<body package="SAM-Interface" selector="processNextInventoryChangeEvent">processNextInventoryChangeEvent
	
	^inventoryChangeQueue next value</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>processing</category>

<body package="SAM-Interface" selector="doEvent:">doEvent: event 
	
	self doInventoryChange: 
		[[self eventCallback value: event] 
			on: Error
			do: [:ex | self logEventProcessingError: ex]]</body>

<body package="SAM-Interface" selector="doInventoryChange:">doInventoryChange: aBlock

	inventoryChangeQueue nextPut: aBlock</body>

<body package="SAM-Interface" selector="isMissedJmsEvent:">isMissedJmsEvent: anElement 
	
		| tag body |
	body := 
		anElement anyElementNamed: 
			(XML.NodeTag 
				qualifier: ''
				ns: 'xmlapi_1.0'
				type: 'jms').
	body ifNotNil: 
		[tag := 
			body anyElementNamed: 
				(XML.NodeTag 
					qualifier: ''
					ns: 'xmlapi_1.0'
					type: 'state')].
	(tag isNil or: [tag elements isEmpty]) 
		ifTrue: [^nil].
	^tag elements first text includesSubString: 'jmsMissedEvent'</body>

<body package="SAM-Interface" selector="markFullDumpInterrupted">markFullDumpInterrupted

	"This will force a full dump on reconnect"
	lastServerStartTime := nil.
	self stop.
	self start.</body>

<body package="SAM-Interface" selector="processStateChangeXmlEvent:objectType:">processStateChangeXmlEvent: anElement objectType: aType 
	
	| result activeIP startTime subResult |
	(self isMissedJmsEvent: anElement) 
		ifTrue: 
			[descriptor schema processFullDumpFor: self connection samInterface.
			^#()].
	result := 
		self 
			processXmlEvent: anElement
			objectType: aType.
	result size ~= 4 
		ifTrue: [^result].
	subResult := result at: 4.
	subResult isEmpty 
		ifTrue: [^result].
	activeIP := 
		subResult first 
			at: 'sysPrimaryIp'
			ifAbsent: [^result].
	descriptor soapURI ifNotNil: 
		[:uri | 
		uri 
			host: activeIP
			port: uri port].
	startTime := 
		(subResult first 
			at: 'sysStartTime'
			ifAbsent: [^result]) asNumber.
	(lastServerStartTime isNil or: [lastServerStartTime ~= startTime]) 
		ifTrue: 
			[lastServerStartTime := startTime.
			descriptor schema processFullDumpFor: self connection samInterface].
	^result</body>
</methods>


<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>accessing</category>

<body package="SAM-Interface" selector="connection:">connection: anObject
	connection := anObject.
	descriptor := anObject descriptor.</body>

<body package="SAM-Interface" selector="filter">filter
	^descriptor jmsFilter</body>

<body package="SAM-Interface" selector="jarPath">jarPath
	^descriptor jarPath</body>

<body package="SAM-Interface" selector="javaPath">javaPath
	^descriptor javaPath</body>

<body package="SAM-Interface" selector="jmsClasses">jmsClasses
	^descriptor jmsClasses</body>

<body package="SAM-Interface" selector="jmsEvents">jmsEvents
	^descriptor jmsEvents</body>

<body package="SAM-Interface" selector="jmsProperties">jmsProperties
	^descriptor jmsProperties</body>

<body package="SAM-Interface" selector="jmsTimeout">jmsTimeout
	"&lt;Integer&gt; Answer the number of seconds that the receiver is allowed to go without a keep alive message from the JMS listener before the listener is considered stale."

	^descriptor jmsTimeout</body>

<body package="SAM-Interface" selector="password">password
	^descriptor password</body>

<body package="SAM-Interface" selector="queueId">queueId
	^descriptor queueId</body>

<body package="SAM-Interface" selector="samVersion">samVersion
	^descriptor samVersion</body>

<body package="SAM-Interface" selector="uri">uri
	^descriptor jmsURI</body>

<body package="SAM-Interface" selector="user">user
	^descriptor user</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>process management</category>

<body package="SAM-Interface" selector="processStdout:">processStdout: testBlock 
	"This method is called by the eventService and is designed to run forever, reading infomration from the pipe connection with the external JMS listener process"
	
	self 
		processStrings: [self getStringFrom: stdout]
		do: [:str | 					]
		while: [testBlock value and: [externalProcess notNil]]</body>

<body package="SAM-Interface" selector="startExternalProcess">startExternalProcess
	
	| args |
	args := 
		Array 
			with: '-jar'
			with: self jarPath
			with: self uri host , ':' , self uri port asString.
	externalProcess ifNotNil: [self stopExternalProcess].
	receivedKeepAlive := false.
	stdioConnection := 
			ExternalProcess defaultClass 
				pipeConnectionWithErrorFor: self javaPath
				arguments: args
				setProcessDescriptor: [:p | externalProcess := p].
	self logProcessStarted: externalProcess pid.
	stdin := stdioConnection writeStream.
	stdout := stdioConnection readStream.
	stderr := stdioConnection errorReadStream.
	lastKeepAlive := Time microsecondClock.
	stderrListener restart.
	stdoutListener restart.
	"Only do the following if we talking to the 2.1 jms interface."
	self samVersion = '2.1' 
		ifTrue: 
			[self cmdAddUser: self user.
			self cmdAddPassword: (self hashedPassword).
			self cmdAddQueueId: self queueId].
	self samVersion = '3.0' 
		ifTrue: [self cmdAddUser: self user.
			    self cmdAddPassword: self password pvDecrypt.
			    self cmdAddQueueId: self queueId.
			    self cmdAddFilter: self filter]
		ifFalse: 
			[self jmsClasses do: [:ea | self cmdAddClass: ea].
			self jmsProperties do: [:ea | self cmdAddProperty: ea]].</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>processing</category>

<body package="SAM-Interface" selector="processEvent:">processEvent: strm 
	"Process a string coming from the JMS interface (this could be an event or heartbeat)"
	
	| event tmp |
	strm next.
	"Consume the 'C'"
	self environment do: [event := Smee.SmeeArray new].
	[strm atEnd] 
		whileFalse: 
			[tmp := String readNetStringFrom: strm.
			tmp = self keepAliveEventString 
				ifTrue: [^self processKeepAlive].
			tmp = self stateChangeEventString 
				ifTrue: [^self processStateChangeEvent: strm].
			tmp = self generalExceptionString 
				ifTrue: [^self].
			tmp = self jmsExceptionString 
				ifTrue: [^self processJmsException: strm].
			tmp := 
				tmp 
					copyFrom: 2
					to: tmp size.
			event add: tmp].
	self doEvent: event</body>

<body package="SAM-Interface" selector="processXmlEvent:">processXmlEvent: strm 
	"Process an xml element coming from the JMS interface (this could be an event or heartbeat)"
	
	| aType anElement |
	strm next.
	"Consume the 'X'"

	[anElement := XML.XMLParser new parseElement: strm.
	aType := self getObjectType: anElement.
	aType = self keepAliveEventXmlString 
		ifTrue: 
			[self processKeepAlive.
			^self 
				processXmlEvent: anElement
				objectType: aType
				eventType: aType
				objectName: nil].
	self updateLastKeepAliveTimestamp.
	aType = self stateChangeEventXmlString 
		ifTrue: 
			[^self 
				processStateChangeXmlEvent: anElement
				objectType: aType].
	^(self jmsClasses includes: aType) 
		ifTrue: 
			[self 
				processXmlEvent: anElement
				objectType: aType]
		ifFalse: 
			[self 
				processXmlEvent: anElement
				objectType: aType
				eventType: 'IgnoredEvent'
				objectName: nil]] 
					on: Error
					do: [:ex | self logEventProcessingError: ex]</body>

<body package="SAM-Interface" selector="processXmlEvent:objectType:eventType:objectName:">processXmlEvent: anElement
	objectType: anObjectType
	eventType: anEventType
	objectName: anObjectName
	
	| eventColl |
	eventColl := OrderedCollection new.
	eventColl
		add: anEventType;
		add: anObjectType;
		add: anObjectName.
	self 
		processFilteredXmlEvent: anElement
		eventType: anEventType
		into: eventColl.
	self doEvent: eventColl.
	^eventColl</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>starting and stopping</category>

<body package="SAM-Interface" selector="start">start
	
	self uri ifNil: [^self].
	ObjectMemory addDependent: self.
	monitorService restart.
	inventoryChangeService start.</body>

<body package="SAM-Interface" selector="stop">stop

	monitorService stop.
	inventoryChangeService stop.
	ObjectMemory removeDependent: self.</body>

<body package="SAM-Interface" selector="update:with:from:">update: anAspect with: arguments from: anObject
	"Shut down the external process when the image is exiting"

	anAspect == #aboutToQuit
		ifTrue: 
			[self stopExternalProcess.
			self stop]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>initialize-release</category>

<body package="SAM-Interface" selector="initialize">initialize

	super initialize.
	eventCallback := [ :event | ].
	lastKeepAlive := Time microsecondClock.
	receivedKeepAlive := false.
	monitorService :=
		Kom.PluggableService new
			name: 'SAM JMS Process Monitor';
			runCallback: [ :testBlock |  self reportDeathOf: [self runJmsProcess: testBlock] as: 'JMS Process Monitor'];
			priority: 45;
			yourself.
	stdoutListener :=
		Kom.PluggableService new
			name: 'SAM JMS stdout listener';
			runCallback: [ :testBlock | self reportDeathOf: [self processStdout: testBlock] as: 'JMS stdout listener'];
			priority: 45;
			yourself.
	stderrListener :=
		Kom.PluggableService new
			name: 'SAM JMS stderr listener';
			runCallback: [ :testBlock |  self reportDeathOf: [self processStderr: testBlock] as: 'JMS stderr listener'];
			priority: 45;
			yourself.
	inventoryChangeQueue := SharedQueue new.
	inventoryChangeService := 
		Kom.PluggableService new
			name: 'Inventory Change Service';
			runCallback: [ :testBlock |  self reportDeathOf: [self processInventoryChangeEvents: testBlock] as: 'JMS stderr listener'];
			priority: 45;
			yourself.</body>
</methods>


<remove-selector>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <selector>jmsEvents:</selector>
</remove-selector>

<remove-selector>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <selector>jmsTimeout:</selector>
</remove-selector>

<remove-selector>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <selector>jmsProperties:</selector>
</remove-selector>

<remove-selector>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <selector>user:</selector>
</remove-selector>

<remove-selector>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <selector>queueId:</selector>
</remove-selector>

<remove-selector>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <selector>uri:</selector>
</remove-selector>

<remove-selector>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <selector>jmsClasses:</selector>
</remove-selector>

<remove-selector>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <selector>javaPath:</selector>
</remove-selector>

<remove-selector>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <selector>samVersion:</selector>
</remove-selector>

<remove-selector>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <selector>jarPath:</selector>
</remove-selector>

<remove-selector>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <selector>password:</selector>
</remove-selector>

<remove-selector>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <selector>filter:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvSAMDeviceConnection</class-id> <category>connection</category>

<body package="SAM-Interface" selector="jmsInterfaceClass">jmsInterfaceClass
	
	^PvSAMJmsInterface</body>
</methods>


<methods>
<class-id>PROVISO.PvSAMDeviceConnection</class-id> <category>connection</category>

<body package="SAM-Interface" selector="basicConnect">basicConnect
	"&lt;self&gt; Create an HttpClient and try to ping the server...an exception will be signaled if there is any problem"
	
	self critical: 
		[self client: self newClient.
		self descriptor jmsURI ifNotNil: 
			[self jmsInterface: (self jmsInterfaceClass on: self).
			self setEventCallbackBlock]]</body>
</methods>



</st-source>
